(function($){
    var jsonUrl;
    var timeout;
    var mainContainer;
    var queueContainer;
    var dialogContainer;
    var graphLength;

    var speed = new Array();
    
    $.fn.nntpgrab = function(options) {
        var defaults = {
            timeout: 1, //Timeout in seconds
            jsonUrl: '', //URL to the NNTPGrab JSON-RPC server
            graphLength: 60 //The length of the speedGraph in seconds
            };

            var opts = $.extend(defaults, options);

        return this.each(function() {
            jsonUrl = opts.jsonUrl;
            timeout = opts.timeout * 1000;
            graphLength = opts.graphLength
            mainContainer = this;
            queueContainer = $(mainContainer).find("#queue-list");
            dialogContainer = $("#dialog");

            $("*").noContext();
            
            $(mainContainer).tabs({
                "select": function(event, ui) {
                    switch(ui['index']){
                        case 0:
                            $(queueContainer).nntpgrabQueue();
                            break;
                    }
                }
            });

            $(queueContainer).nntpgrabQueue();

            var method = "";
            var params = [];
            $("#schedular").button({
                text: false,
                label: 'start',
                icons: {
                    primary: 'ui-icon-play'
                }
            }).click(function() {
                var options;
                if ($(this).text() == 'start') {
                    options = {
                        label: 'pause',
                        icons: {
                            primary: 'ui-icon-pause'
                        }
                    };
                    method = "nntpgrab_schedular_start";
                    params = [];
                } else {
                    options = {
                        label: 'start',
                        icons: {
                            primary: 'ui-icon-play'
                        }
                    };
                    method = "nntpgrab_schedular_stop";
                    params = [true];
                }
                $(this).button('option', options);
                jsonRequest({
                    "method": method,
                    "params": params,
                    "id":1
                });
            });


            jsonRequest({
                "method": "nntpgrab_schedular_get_state",
                "params": []
            }, function(){
                schedularStateChanged(parseInt(this['result']));
            });

            $("#nzb").button({
                text: false,
                label: 'nzb',
                icons: {
                    primary: 'ui-icon-disk'
                }
            }).click(function() {
                alert("Ik kan nog niks ;)");
            });

                
            jsonRequest({
                "method":"nntpgrab_get_version_info",
                "params":[],
                "id":1
            }, function(){
                var infoHTML = "Welcome to NNTPGrab<br>";
                infoHTML += "<br>";
                infoHTML += "You are using version:	" + this['result']['version'] + "<br>";
                infoHTML += "This version was built on " + this['result']['api_version'] + "<br>";
                infoHTML += "<br>";
                infoHTML += "For more information, go to our website <a target=\"_blank\" href=\"http://www.nntpgrab.nl\">http://www.nntpgrab.nl</a>";

                $(mainContainer).find("#information").html(infoHTML);
                $(mainContainer).find("#information").css("text-align", "center");
            });

            events(0);
        });
    };

    $.fn.nntpgrabQueue = function(){
        jsonRequest({
            "method":"nntpgrab_schedular_get_all_tasks",
            "params":[],
            "id":1
        }, function(){
            var html = "";
            for(var i =0; i < this['result'].length; i++){
                var collection = this['result'][i];
                html += "<div><h3><a href=\"#\" title=\""  + collection['collection_name'] +  "\">" + collection['collection_name'] + "<div class=\"progressCollection\" title=\"" + progress(collection['total_size'], collection['total_size_remaining']) + "\"><div class=\"progressText\">" + progress(collection['total_size'], collection['total_size_remaining']) + "%</div></div></a></h3>";
                html += "<div class=\"accordion-container\">";
                html += "<table id=\"" + collection['collection_name'] + "\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"99%\">";

                html += "<tr style=\"font-weight: bolder;\">";
                html += "<td>Subject</td>";
                html += "<td>Poster</td>";
                html += "<td>Status</td>";
                html += "<td>Progress</td>";
                html += "<td>Groups</td>";
                html += "</tr>";
                    
                for(var j = 0; j < collection['files'].length; j++){
                    var file = collection['files'][j];
                    html += "<tr class=\"schedularPart\">";
                    html += "<td class=\"subject\" style=\"width: 59%\">" + file['subject'] + "</td>";
                    html += "<td class=\"poster\" style=\"width: 10%\">" + file['poster'] + "</td>";
                    html += "<td class=\"state\" style=\"width: 75px\">" + schedularState(file['status']) + "</td>";
                    html += "<td class=\"progress\" style=\"width: 10%\"><div class=\"progressBar\" title=\"" + progress(file['file_size'], file['file_size_remaining']) + "\"><div class=\"progressTextSmall\">" + progress(file['file_size'], file['file_size_remaining']) + "%</div></div></td>";
                    html += "<td class=\"groups\" style=\"width: 10%\">" + groups(file['groups']) + "</td>";
                    html += "</tr>";
                }

                html += "</table></div></div>";
            }
            $(queueContainer).accordion('destroy');
            $(queueContainer).empty();
            $(queueContainer).html(html);

            schedularInit();
        });
    };

    function schedularInit(){
        $(queueContainer).find(".progressBar").each(function(){
            $(this).progressbar({
                value: parseInt($(this).attr("title"))
            });
        });

        var stop = false;
        $(queueContainer).find("h3").click(function(event) {
            if (stop) {
                event.stopImmediatePropagation();
                event.preventDefault();
                stop = false;
            }
        });
        $(queueContainer).accordion({
            animated: false,
            autoHeight: false,
            active: false,
            collapsible: true,
            header: "div > h3"
        }).sortable({
            axis: "y",
            handle: "h3",
            stop: function(e, ui) {
                stop = true;
                jsonRequest({
                    "method":"nntpgrab_schedular_move_collection",
                    "params":[$(ui.item).find("h3 a").attr('title'),parseInt($(e.target).children().index(ui.item))]
                })
            }
        });

        $(queueContainer).find(".progressCollection").each(function(){
            $(this).progressbar({
                value: parseInt($(this).attr("title"))
            });
        });

        $(queueContainer).find("div h3,a,span").contextMenu({
            menu: 'schedularMenu'
        },
        function(action, el, pos) {
            var method = "";
            var params = null;
            switch(action){
                case 'remove':
                    $(dialogContainer).dialog('destroy');
                    $(dialogContainer).attr('title', "Remove Collection?");
                    $(dialogContainer).html("Are you sure you want to remove this collection?");
                    $(dialogContainer).dialog({
                        resizable: false,
                        height:170,
                        width: 500,
                        modal: true,
                        buttons: {
                            Ok: function() {
                                jsonRequest({
                                    "method": "nntpgrab_schedular_del_file_from_queue",
                                    "params": [$(el).find("a").attr("title"),null]
                                });

                                $(this).dialog('close');
                            },
                            Cancel: function() {
                                $(this).dialog('close');
                            }
                        }
                    });
                    
                    break;
                case 'restart':
                    $(dialogContainer).dialog('destroy');
                    $(dialogContainer).attr('title', "Restart Collection?");
                    $(dialogContainer).html("Are you sure you want to restart this collection?");
                    $(dialogContainer).dialog({
                        resizable: false,
                        height:170,
                        width: 500,
                        modal: true,
                        buttons: {
                            Ok: function() {
                                jsonRequest({
                                    "method": "nntpgrab_schedular_restart_file",
                                    "params": [$(el).find("a").attr("title"),null]
                                });
                                $(el).find("a .progressCollection").progressbar('option','value',0);
                                $(el).find("a .progressText").html("0%");

                                $(el).parent().find(".schedularPart").each(function(){
                                    console.log(this);
                                    $(this).find(".state").html(schedularState(0));
                                    $(this).find(".progressBar").each(function(){
                                        $(this).progressbar('option', 'value', 0);
                                        $(this).find(".progressTextSmall").html("0%");
                                    });
                                });
                                $(this).dialog('close');
                            },
                            Cancel: function() {
                                $(this).dialog('close');
                            }
                        }
                    });
                    break;
            }
            if(method != ""){
                alert();
                
            }
        });
    }

    function events(id){
        jsonRequest({
            "method":"system.events",
            "params":[id],
            "id": id
        }, function(){
            for(var i=0; i<this['result'].length; i++){
                var object = this['result'][i];
                switch(object['type']){
                    case 'traffic_monitor_update':
                        speedGraph(object['data']);
                        break;
                    case 'file_download_state_update':
                        fileStateChange(object['data']);
                        break;
                    case 'schedular_state_changed':
                        schedularStateChanged(parseInt(object['data']['new_state']));
                        break;
                    case 'collection_moved':
                        $(queueContainer).nntpgrabQueue();
                        break;
                    case 'collection_added':
                        $(queueContainer).nntpgrabQueue();
                        break;
                    case 'collection_modified':
                        $(queueContainer).nntpgrabQueue();
                        break;
                    case 'collection_removed':
                        $(queueContainer).nntpgrabQueue();
                        break;
                }
                id = object['id'];
            }
        });
        setTimeout(function(){
            events(id);
        },timeout);
    }

    function schedularStateChanged(newState){
        if(newState == 0){
            $("#schedular").button({
                label: 'pause',
                icons: {
                    primary: 'ui-icon-pause'
                }
            });
        } else {
            $("#schedular").button({
                label: 'start',
                icons: {
                    primary: 'ui-icon-play'
                }
            });
        }
    }
    
    function fileStateChange(object){
        $(queueContainer).find(".schedularPart .subject").each(function(){
            if($(this).html() == object['subject']){
                var num_parts_done = parseFloat(object['num_parts_done']);
                var num_parts_total = parseFloat(object['num_parts_total']);
                var num_parts_failed = parseFloat(object['num_parts_failed']);
                var state = 0;
                if(num_parts_done == num_parts_total){
                    state = 4;
                } else if((num_parts_done + num_parts_failed) == num_parts_total){
                    state = 5;
                } else if(num_parts_done > 0 && num_parts_done < num_parts_total){
                    state = 1;
                }

                var progressCalc = progress(object['file_size'], object['file_size_remaining']);
                var progressTotal = progress(object['total_size'], object['total_size_remaining']);
                var schedular = $(this).parent();
                
                $(schedular).find(".state").html(schedularState(state));
                $(schedular).find(".progress .progressBar").each(function(){
                    $(this).progressbar('option', 'value', progressCalc);
                    $(this).find(".progressTextSmall").html(progressCalc + "%");
                });

                $(queueContainer).find("div > h3 > a").each(function(){
                    if($(this).attr("title") == object['collection_name']){
                        $(this).find(".progressCollection").each(function(){
                            $(this).progressbar('option', 'value', progressTotal);
                            $(this).find(".progressText").html(progressTotal + "%");
                        });
                    }
                });
            }
        });
    }

    function speedGraph(data){
        var canvas = document.getElementById("speedGraph");
        var ctx = canvas.getContext("2d");

        ctx.clearRect(0, 0, canvas.width, canvas.height);

        var val;
        if(data == null){
            val = 0;
        } else {
            val = data['bytes_received10'];
        }
        if(speed.length == graphLength){
            speed.shift();
            speed.push(val);
        } else {
            speed.push(val);
        }

        ctx.strokeStyle = "rgb(55,93,129)";

        ctx.beginPath();

        var baseX = canvas.width / (speed.length - 1);
        var baseY = 0;
        var baseYMax = 0;
        var baseYAverage = 0;
        var baseYCur = 0;

        for(var i=0; i<speed.length; i++){
            if(speed[i] > baseYMax){
                baseYMax = speed[i];
            }
            baseYAverage += speed[i];
            baseYCur = speed[i];
        }
        baseYAverage = baseYAverage / speed.length;
        baseY = canvas.height / (baseYMax + (baseYAverage / 4));

        for(var j=0; j<speed.length; j++){
            if(j==0){
                ctx.moveTo(j, canvas.height - (speed[j] * baseY));
            } else {
                ctx.lineTo(j * baseX, canvas.height - (speed[j] * baseY));
            }
        }

        ctx.stroke();

        $("#speedAVG").html("Average: " + Math.round(baseYAverage / 1024) + " kb&nbsp;");
        $("#speedMAX").html("Maximum: " + Math.round(baseYMax / 1024) + " kb&nbsp;");
        $("#speedCUR").html("Current: " + Math.round(baseYCur / 1024) + " kb&nbsp;");
    }

    function groups(groups){
        var returnVal = "";
        for(var i = 0; i < groups.length; i++){
            var group = groups[i];
            if(returnVal == ""){
                returnVal = group;
            } else {
                returnVal += ";&nbsp;" + group;
            }
        }
        return returnVal;
    }

    function progress(total, remaining){
        return Math.floor(100 *  (total - remaining) / total);
    }

    function schedularState(status){
        switch(status){
            case 0:
                return "Queued";
            case 1:
                return "Downloading";
            case 2:
                return "Waiting";
            case 3:
                return "Decoding";
            case 4:
                return "<span style=\"color: green;\">Finished</span>";
            case 5:
                return "<span style=\"color: red;\">Finished</span>";
            case 6:
                return "<span style=\"color: red;\">Finished</span>";
            case 7:
                return "Skipped";
        }
    }

    function jsonRequest(data, callback) {
        $.ajax({
            "dataType": "json",
            "type": "POST",
            "data": $.toJSON(data),
            "success": function(result) {
                if(typeof callback == 'function'){
                    callback.call(result, data);
                }
            },
            "processData": false,
            "contentType": "application/json",
            "url": jsonUrl,
            "password": "admin",
            "username": "admin"
        });
    }
})(jQuery);